﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProgramovaniSoutez
{
    public partial class MainForm : Form
    {
        int skore = 0;
        string cas = "";

        Hra hra = null;

        bool mouseDown = false;
        Point mousePos = new Point();

        PointF scaleFactor = new PointF(1.0f, 1.0f);

        public MainForm()
        {
            InitializeComponent();
        }

        int Skore
        {
            get { return skore; }
            set
            {
                skore = value;

                skoreToolStripMenuItem.Text = $"Skore: {skore}";
            }
        }

        string Cas
        {
            get { return cas; }
            set
            {
                cas = value;

                limitToolStripMenuItem.Text = $"Zbývá: {cas}";
            }
        }

        void Form1_Paint(object sender, PaintEventArgs e)
        {
            hra?.Draw(e.Graphics);
        }

        void Form1_Resize(object sender, EventArgs e)
        {
            scaleFactor = new PointF((float)Width / 425.0f, (float)Height / 500.0f);

            if(hra != null)
                hra.Scale = scaleFactor;
        }

        void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            mouseDown = true;

            hra?.MouseClick(e.Location);
        }

        void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            mouseDown = false;
        }

        void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mousePos = e.Location;
        }

        void nováHraToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // založení hry
            NewGame newgame = new NewGame();

            if(newgame.ShowDialog() == DialogResult.OK)
            {
                hra = new Hra(newgame.TimeLimit.Checked, newgame.timePicker.Value);
                hra.Ended += (sender2, e2) =>
                {
                    MessageBox.Show(e2.ToString());
                    MessageBox.Show($"Počet bodů hráče: {hra.hrac1}");
                };
                hra.ScoreUpdate += (sender2, e2) =>
                {
                    Skore += (int)e2;
                };
                hra.TimeUpdate += (sender2, e2) =>
                {
                    Cas = e2.ToString();
                };

                hra.Load(newgame.HraciPlocha.Text);

                timer.Start();
            }
        }

        void timer_Tick(object sender, EventArgs e)
        {
            Invalidate();

            hra?.Update();
        }

        void timer2_Tick(object sender, EventArgs e)
        {
            hra?.Update2();
        }
    }
}
